/*
  rgbx Simple Test.c
*/

#include <propeller.h>
#include "rgbx.h"

#define LED_PIN     13                        // led chain pin and count
#define LED_COUNT   4

int lightsA[] = { COLOR_RED, COLOR_YELLOW,    // 4-light pattern A
                  COLOR_GREEN, COLOR_BLUE }; 
int lightsB[] = { COLOR_YELLOW, COLOR_RED,    // 4-light pattern B
                  COLOR_BLUE, COLOR_GREEN };

void pause(int ms);
int ticks_per_ms;

void main()                                   // Main function
{
  ticks_per_ms = CLKFREQ / 1000;

  rgbxb_start(LED_PIN, LED_COUNT);          // Open leds instance
  
  int i = 0;                                  // Counting variable

  while(1)                                    // Main loop
  {
    i = (i + 1) % 2;                          // i counts 0, 1, 0, 1,...                                      
    if(i == 0)                                // if i is 0
      ws2812_set(lightsA);      
    else                                      // Otherwise...
      ws2812_set(lightsB);      
    pause(100);  
  }      
}

void pause(int ms)
{
    waitcnt(CNT + ms * ticks_per_ms);
}
